#include <stdio.h>
#include <stdint.h>
#include <systypes/format.h>

#define FMT32x "%" pFMT32 "x"
#define FMT64x "%" pFMT64 "x"
#define OFFSET(obj, mem) ((char *) &(obj)->mem - (char *) obj)

struct A
{
  uint32_t a;
  uint64_t b;
  uint64_t c;
} __attribute__ ((packed));

struct B
{
  uint32_t a;
  uint64_t b;
  uint64_t c;
};

struct C
{
  uint32_t a;
  uint32_t b;
  uint64_t c;
};

int main(int argc, char *argv[])
{
  (void) argc; (void) argv;

  struct A a = {1, 2, 3};
  struct B b = {1, 2, 3};
  struct C c = {1, 2, 3};
  uint32_t m[6] = {1, 2, 3, 4, 5, 6};
  struct A *ma = (struct A *) m;
  struct A *ma1 = (struct A *) (m + 1);

  printf("a.a @ offset %d = " FMT32x "\n", OFFSET(&a, a), a.a);
  printf("a.b @ offset %d = " FMT64x "\n", OFFSET(&a, b), a.b);
  printf("a.c @ offset %d = " FMT64x "\n\n", OFFSET(&a, c), a.c);
  printf("b.a @ offset %d = " FMT32x "\n", OFFSET(&b, a), b.a);
  printf("b.b @ offset %d = " FMT64x "\n", OFFSET(&b, b), b.b);
  printf("b.c @ offset %d = " FMT64x "\n\n", OFFSET(&b, c), b.c);
  printf("c.a @ offset %d = " FMT32x "\n", OFFSET(&c, a), c.a);
  printf("c.b @ offset %d = " FMT32x "\n", OFFSET(&c, b), c.b);
  printf("c.c @ offset %d = " FMT64x "\n\n", OFFSET(&c, c), c.c);
  printf("ma.a @ offset %d = " FMT32x "\n", OFFSET(ma, a), ma->a);
  printf("ma.b @ offset %d = " FMT64x "\n", OFFSET(ma, b), ma->b);
  printf("ma.c @ offset %d = " FMT64x "\n\n", OFFSET(ma, c), ma->c);
  printf("ma1.a @ offset %d = " FMT32x "\n", OFFSET(ma1, a), ma1->a);
  printf("ma1.b @ offset %d = " FMT64x "\n", OFFSET(ma1, b), ma1->b);
  printf("ma1.c @ offset %d = " FMT64x "\n\n", OFFSET(ma1, c), ma1->c);

  return 0;
}
